#include "robotTask.hpp"
#include "robot.hpp"
#include "../drivers/pwm.h"
#include "userInterface.hpp"
#include "../osHandles.h"
#include "../utils/rprintf.h"     // rprintf
#include "../fat/ff.h"            // FAT File System Library
#include "../fat/diskio.h"        // Disk IO Initialize SPI Mutex
#include "../drivers/sta013.h"
#include "../drivers/pcm1774.h"

void robotTask(void *p)
{
	OSHANDLES *osHandles = (OSHANDLES*) p;

	int pwmPulseWidth = 20000;//set to 40k or 20k
	Motion  move = Stop;

	for(;;)
	{
		//rprintf("Entering robotTask for loop\n");
		vTaskDelay(500);

		if(xQueueReceive(osHandles->queue.userCommand, &move, portMAX_DELAY))
		{
			//rprintf("motor(): Received user command: %d", move);

			while(0==uxQueueMessagesWaiting(osHandles->queue.userCommand))
			{
				switch(move)
				{
				case Forward:
					walkForward(pwmPulseWidth);
					//rprintf("Forward\n");
					break;

				case Backward:
					walkBackward(pwmPulseWidth);
					//rprintf("Backward\n");
					break;

				case Left:
					turnLeft(pwmPulseWidth);
					//rprintf("Left\n");
					break;

				case Right:
					turnRight(pwmPulseWidth);
					//rprintf("Right\n");
					break;

				case Stop:
					stopRobot(pwmPulseWidth);
					//rprintf("Stop\n");
					break;
				}
			}
		}
	}
}
